Index: pcmmio/original/Makefile
===================================================================
--- pcmmio/original/Makefile	(revision dc256a455be7910f1b9e84fd51f47ae623a42509)
+++ pcmmio/original/Makefile	(revision 2bae2aa487be5c21a8eac5de5ba3c19d73b1651c)
@@ -1,61 +1,68 @@
+# $Header$
 #
-#  $Id$
+# $Id$
+#
+# $Log$
 #
 
-RTEMS_MAKEFILE_PATH=${HOME}/centaur/install/i386-rtems4.10/pc386/
-#
-#  RTEMS_MAKEFILE_PATH is typically set in an environment variable
-#
+MAJOR = 115
 
-#MAINS= buffered.c dacbuff.c dacout.c flash.c getall.c getvolt.c \
-#  poll.c repeat.c simple_rtems.c pcmmio_shell.c
+CFLAGS += -DMAJOR_NUM=$(MAJOR)
 
-MAINS= pcmmio_shell.c
+# Test Makefile
 
-PGMS=$(MAINS:%.c=${ARCH}/%.exe)
+ifneq ($(KERNELRELEASE),)
+	obj-m := pcmmio.o
+else
+	KERNELDIR ?= /lib/modules/$(shell uname -r)/build
+	PWD := $(shell pwd)
 
-# optional managers required
-MANAGERS=all
-#DEFINES += -DTESTING
+default:
+	$(MAKE) -C $(KERNELDIR) M=$(PWD) modules
+endif
 
-# C source names
-#SHARED_CSRCS += mio_io_linux.c
-SHARED_CSRCS = mio_io.c kbhit.c 
-SHARED_CSRCS += main_pcmmio_adc_mode.c
-SHARED_CSRCS += main_pcmmio_din.c main_pcmmio_dout.c
-SHARED_CSRCS += main_pcmmio_adc.c main_pcmmio_dac.c
-SHARED_CSRCS += main_pcmmio_irq.c
-SHARED_CSRCS += main_pcmmio_benchmark.c
-SHARED_CSRCS += mio_io_rtems.c
-SHARED_CSRCS += FilesystemImage.c
+mio_io.o: mio_io.c mio_io.h Makefile
+	gcc -c $(CFLAGS) mio_io.c
 
-SHARED_COBJS = $(SHARED_CSRCS:%.c=${ARCH}/%.o)
-SHARED_CONFIG = ${ARCH}/rtems_config.o
+nodes:
+	mknod pcmmio c $(MAJOR) 0
+	chmod a+rw pcmmio
 
-CLEAN_ADDITIONS += FilesystemImage FilesystemImage.c FilesystemImage.h
+all:    default nodes poll flash getvolt dacout getall repeat buffered dacbuff
 
-include $(RTEMS_MAKEFILE_PATH)/Makefile.inc
-include $(RTEMS_CUSTOM)
-include $(PROJECT_ROOT)/make/leaf.cfg
+dacbuff: dacbuff.c mio_io.o mio_io.h Makefile kbhit.c
+	gcc $(CFLAGS) -static dacbuff.c kbhit.c mio_io.o -o dacbuff
+	chmod a+x dacbuff
+	
+buffered: buffered.c mio_io.o mio_io.h Makefile kbhit.c
+	gcc $(CFLAGS) -static buffered.c kbhit.c mio_io.o -o buffered
+	chmod a+x buffered
+	
+repeat: repeat.c mio_io.o mio_io.h Makefile kbhit.c
+	gcc $(CFLAGS) -D_REENTRANT -static repeat.c kbhit.c mio_io.o -o repeat -lpthread
+	chmod a+x repeat
 
-LDFLAGS += -g
-OBJS= $(COBJS) $(CXXOBJS) $(ASOBJS) $(SHARED_COBJS) $(SHARED_CONFIG)
+flash: flash.c mio_io.h kbhit.c mio_io.o Makefile
+	gcc $(CFLAGS) -static flash.c kbhit.c mio_io.o -o flash
+	chmod a+x flash
 
-all:    ${ARCH} FilesystemImage.c FilesystemImage.h $(OBJS) $(PGMS)
+getvolt: getvolt.c mio_io.h mio_io.o Makefile
+	gcc $(CFLAGS) -static getvolt.c mio_io.o -o getvolt
+	chmod a+x getvolt
 
-${ARCH}/pcmmio_shell.exe: pcmmio_shell.c $(OBJS)
-	$(CC) $(LDFLAGS) -o $@ $< $(SHARED_COBJS)
+getall: getall.c mio_io.h mio_io.o Makefile
+	gcc $(CFLAGS) -static getall.c mio_io.o -o getall
+	chmod a+x getall
 
-${ARCH}/%.exe: %.c $(OBJS)
-	$(CC) $(LDFLAGS) -o $@ $< $(SHARED_COBJS) $(SHARED_CONFIG)
+dacout: dacout.c mio_io.h mio_io.o Makefile
+	gcc $(CFLAGS) -static dacout.c mio_io.o -o dacout
+	chmod a+x dacout
 
-FilesystemImage: rootfs/test_adc rootfs/set_adc_modes
-	(cd rootfs ; tar cf - --exclude=.svn \
-	  --exclude=CVS --exclude=.cvsignore .) >$(@)
+poll:  poll.c mio_io.o mio_io.h Makefile
+	gcc $(CFLAGS) -D_REENTRANT -static poll.c mio_io.o -o poll -lpthread
+	chmod a+x poll
+ 
+clean:
+	rm -rf *.o *~ core .depend .*.cmd *.ko *.mod.c .tmp_versions pcmmio
 
-FilesystemImage.c FilesystemImage.h: FilesystemImage
-	$(PROJECT_ROOT)/bin/rtems-bin2c FilesystemImage FilesystemImage
 
-FilesystemImage.o: FilesystemImage.c
-	$(CC) $(CFLAGS) $(CPU_CFLAGS) -c $<
-
Index: pcmmio/original/buffered.c
===================================================================
--- pcmmio/original/buffered.c	(revision dc256a455be7910f1b9e84fd51f47ae623a42509)
+++ pcmmio/original/buffered.c	(revision 2bae2aa487be5c21a8eac5de5ba3c19d73b1651c)
@@ -3,15 +3,21 @@
 /*
 *
+* $Header$
+*
 * $Id$
 *
-* Compile for GNU/Linux with:
+* $Log$
 *
-*   gcc buffered.c kbhit.c mio_io.o -o buffered -lpthread
+*	Compile with :
+*
+*		gcc buffered.c kbhit.c mio_io.o -o buffered -lpthread
 *
 *
-*  This program demonstrates the adc_buffered_channel_conversions function
-*  which allows for a programmed sequence of conversions to be accomplished
-*  with a single call.
+*	This program demonstrates the adc_buffered_channel_conversions function
+*	which allows for a programmed sequence of conversions to be accomplished
+*	with a single call.
+*
 */
+
 
 /* Our IOCTL definitions and all function prototypes */
Index: pcmmio/original/dacbuff.c
===================================================================
--- pcmmio/original/dacbuff.c	(revision dc256a455be7910f1b9e84fd51f47ae623a42509)
+++ pcmmio/original/dacbuff.c	(revision 2bae2aa487be5c21a8eac5de5ba3c19d73b1651c)
@@ -3,16 +3,21 @@
 /*
 *
+* $Header$
+*
 * $Id$
 *
+* $Log$
 *
-* Compile for GNU/Linux with:
+*	Compile with :
 *
-*     gcc dacbuff.c kbhit.c mio_io.o -o dacbuff
+*		gcc dacbuff.c kbhit.c mio_io.o -o dacbuff
 *
 *
-* This program demonstrates the adc_buffered_channel_conversions function
-* which allows for a programmed sequence of conversions to be accomplished
-* with a single call.
+*	This program demonstrates the adc_buffered_channel_conversions function
+*	which allows for a programmed sequence of conversions to be accomplished
+*	with a single call.
+*
 */
+
 
 #include "mio_io.h"    
Index: pcmmio/original/dacout.c
===================================================================
--- pcmmio/original/dacout.c	(revision dc256a455be7910f1b9e84fd51f47ae623a42509)
+++ pcmmio/original/dacout.c	(revision 2bae2aa487be5c21a8eac5de5ba3c19d73b1651c)
@@ -1,13 +1,19 @@
 /* dacout.c WinSystems PCM-MIO driver Demonstration Program
+*
+*  $Header$
 *
 *  $Id$
 *
-* Compile for GNU/Linux with:
-*
-*   gcc dacout.c mio_io.o -o dacout
+*  $Log$
 *
 *
-* This extremely simple program uses the set_dac_voltage function to update
-*  the dac output to a specific voltage.
+*  Compile with :
+*
+*
+*	gcc dacout.c mio_io.o -o dacout
+*
+*
+*	This extremely simple program uses the set_dac_voltage function to update
+*   the dac output to a specific voltage.
 */
 
Index: pcmmio/original/flash.c
===================================================================
--- pcmmio/original/flash.c	(revision dc256a455be7910f1b9e84fd51f47ae623a42509)
+++ pcmmio/original/flash.c	(revision 2bae2aa487be5c21a8eac5de5ba3c19d73b1651c)
@@ -1,12 +1,18 @@
 /* Flash.c WinSystems PCM-MIO driver Demonstration Program
+*
+*  $Header$
 *
 *  $Id$
 *
-*  Compile for GNU/Linux with:
+*  $Log$
 *
-*    gcc flash.c kbhit.c mio_io.o -o flash
 *
-*  This very simple program, toggles each of the 48  DIO lines in succession,
-*  holding it low for 250ms and then releasing it.
+*  Compile with :
+*
+*
+*	gcc flash.c kbhit.c mio_io.o -o flash
+*
+*   This very simple program, toggles each of the 48  DIO lines in succession, holding it low
+*   for 250ms and then releasing it.
 * 
 */
@@ -22,5 +28,4 @@
 
 #include <stdio.h>
-#include <stdlib.h>
 #include <unistd.h>
 #include "mio_io.h"
Index: pcmmio/original/getall.c
===================================================================
--- pcmmio/original/getall.c	(revision dc256a455be7910f1b9e84fd51f47ae623a42509)
+++ pcmmio/original/getall.c	(revision 2bae2aa487be5c21a8eac5de5ba3c19d73b1651c)
@@ -1,11 +1,14 @@
-/* 
- * Demonstration program for use with the WinSystems PCM-MIO driver
- *
- *	$Id$
- *
- * Compile for GNU/Linux with:
- *
- *    gcc -static getall.c mio_io.o -o getall
- */
+/* getall.c Demonstration program for use with the WinSystems PCM-MIO Linux driver
+*
+*	$Header$
+*
+*	$Id$
+*
+*	$Log$
+*
+*	Compile with :
+*
+*			gcc -static getall.c mio_io.o -o getall
+*/
 
 #include <stdio.h>
@@ -13,10 +16,9 @@
 #include "mio_io.h"
 
-/* This program demonstrates usage of the adc_convert_all_channels
- * function call.  This allows for all 16 channels to be quickly converted
- * and the results passed back in an 16 element array. Note that this
- * function does not return voltage values, it returns raw 16-bit data
- * directly from the converter.
- */
+/* This program demonstrates usage of the adc_convert_all_channels function call.
+   This allows for all 16 channels to be quickly converted and the results passed
+   back in an 16 element array. Note that this function does not return voltage values,
+   it returns raw 16-bit data directly from the converter.
+*/
 
 
Index: pcmmio/original/getvolt.c
===================================================================
--- pcmmio/original/getvolt.c	(revision dc256a455be7910f1b9e84fd51f47ae623a42509)
+++ pcmmio/original/getvolt.c	(revision 2bae2aa487be5c21a8eac5de5ba3c19d73b1651c)
@@ -1,16 +1,22 @@
 /* getvolt.c WinSystems PCM-MIO driver Demonstration Program
- *
- *  $Id$
- *
- * Compile for GNU/Linux with:
- *
- *
- *   gcc getvolt.c mio_io.o -o getvolt
- *
- *
- * This program demonstrates the adc_auto_get_channel_voltage
- * function. It reads the voltage on the channel specified
- * prints the value and then exits.
- */
+*
+*  $Header$
+*
+*  $Id$
+*
+*  $Log$
+*
+*
+*  Compile with :
+*
+*
+*	gcc getvolt.c mio_io.o -o getvolt
+*
+*
+*	This program demonstrates the adc_auto_get_channel_voltage
+*	function. It reads the voltage on the channel specified
+*	prints the value and then exits.
+* 
+*/
 
 #include <stdio.h>
Index: pcmmio/original/kbhit.c
===================================================================
--- pcmmio/original/kbhit.c	(revision dc256a455be7910f1b9e84fd51f47ae623a42509)
+++ pcmmio/original/kbhit.c	(revision 2bae2aa487be5c21a8eac5de5ba3c19d73b1651c)
@@ -1,19 +1,29 @@
-/*
- * $Id$
- */
+/* $Header$
+*
+*
+*   Filename : $RCSfile$
+*
+*   $Id$
+*
+*   $Log$
+*   Revision 1.1  2005/04/19 20:39:11  steve
+*   Initial revision
+*
+*
+*
+*/
 
 
 /* These functions are from the Wrox Press Book "Beginning Linux
- * Programming - Second Edition" by Richard Stones and Neil Matthew.
- * (C) 1996 & 1999 and are included here in compliance with the GNU
- * Public license.
- */
+   Programming - Second Edition" by Richard Stones and Neil Matthew.
+   (C) 1996 & 1999 and are included here in compliance with the GNU
+   Public license.
+
+*/
 
 #include <stdio.h>
 #include <termios.h>
-#if defined(__linux__)
-  #include <term.h>
-  #include <curses.h>
-#endif
+#include <term.h>
+#include <curses.h>
 #include <unistd.h>
 
Index: pcmmio/original/mio_io.c
===================================================================
--- pcmmio/original/mio_io.c	(revision dc256a455be7910f1b9e84fd51f47ae623a42509)
+++ pcmmio/original/mio_io.c	(revision 2bae2aa487be5c21a8eac5de5ba3c19d73b1651c)
@@ -1,11 +1,13 @@
-/* mio_io.c
- * WinSystems support module file for the PCM-MIO Linux and RTEMS drivers
- *
- *  $Id$
- *
- *  This file implements all of the supported 'C' language functions.
- *  Where necessary calls are made into a porting layer to access the
- *  actual hardware.
- */
+/* mio_io.c WinSystems support module file for the  PCM-MIO Linux driver */
+/*
+*  $Header$
+*
+*  $Id$
+*
+*  $Log$
+*
+*  This file implements all of the supported 'C' language functions. Where necessary
+*  ioctl call are made into the kernel driver to access the actual hardware.
+*/
 
 #define LIB_DEFINED
@@ -16,4 +18,7 @@
 
 #include <stdio.h>
+#include <fcntl.h>      /* open */ 
+#include <unistd.h>     /* exit */
+#include <sys/ioctl.h>  /* ioctl */
 
 /* These image variable help out where a register is not
@@ -72,4 +77,15 @@
 
 
+/**************************************************************************
+*
+*		USER LIBRARY FUNCTIONS
+*
+***************************************************************************
+*/
+
+int handle = 0;
+char *device_id ="pcmmio";
+char *dev_id    = "/dev/pcmmio";
+
 ///////////////////////////////////////////////////////////////////////////////
 //
@@ -82,5 +98,5 @@
 	mio_error_code = MIO_SUCCESS;
 
-	if(check_handle())   /* Check for chip available */
+    if(check_handle())   /* Check for chip available */
 		return -1;
 
@@ -328,4 +344,31 @@
 ///////////////////////////////////////////////////////////////////////////////
 //
+//		MIO_READ_IRQ_ASSIGNED
+//
+//////////////////////////////////////////////////////////////////////////////
+
+int mio_read_irq_assigned(void)
+{
+unsigned char val;
+
+	mio_error_code = MIO_SUCCESS;
+
+	if(check_handle())   /* Check for chip available */
+		return -1;
+
+
+	/* All of our programming of the hardware is handled at this level so that 
+	   all of the routines that need to shove and IRQ value into hardware will 
+	   use this call.
+   */
+
+    val = ioctl(handle,READ_IRQ_ASSIGNED,NULL);
+
+	return val & 0xff;
+}
+
+
+///////////////////////////////////////////////////////////////////////////////
+//
 //		SET_DAC_SPAN
 //
@@ -433,5 +476,5 @@
 int set_dac_voltage(int channel, float voltage)
 {
-unsigned short  value = 0;
+unsigned short  value;
 float bit_val;
 
@@ -501,4 +544,142 @@
 	return 0;
 }
+
+///////////////////////////////////////////////////////////////////////////////
+//
+//		READ_DIO_BYTE
+//
+//////////////////////////////////////////////////////////////////////////////
+
+unsigned char read_dio_byte(int offset)
+{
+int val;
+
+	mio_error_code = MIO_SUCCESS;
+
+	if(check_handle())   /* Check for chip available */
+		return -1;
+
+	/* All bit operations are handled at this level so we need only
+	read and write bytes from the actual hardware using the driver
+	to handle our ioctl call for it.
+	*/
+
+    val = ioctl(handle,READ_DIO_BYTE,offset);
+
+	return (unsigned char) (val & 0xff);;
+}
+
+///////////////////////////////////////////////////////////////////////////////
+//
+//		MIO_READ_REG
+//
+//////////////////////////////////////////////////////////////////////////////
+
+unsigned char mio_read_reg(int offset)
+{
+int val;
+
+	mio_error_code = MIO_SUCCESS;
+
+	if(check_handle())   /* Check for chip available */
+		return -1;
+
+
+	/* This is a catchall register read routine that allows reading of
+	   ANY of the registers on the PCM-MIO. It is used primarily for
+	   retreiving control and access values in the hardware.
+   */
+
+     val = ioctl(handle,MIO_READ_REG,offset);
+
+	return (unsigned char) (val & 0xff);
+}
+
+///////////////////////////////////////////////////////////////////////////////
+//
+//		MIO_WRITE_REG
+//
+//////////////////////////////////////////////////////////////////////////////
+
+int mio_write_reg(int offset, unsigned char value)
+{
+unsigned short param;
+int val;
+
+	mio_error_code = MIO_SUCCESS;
+
+	if(check_handle())   /* Check for chip available */
+		return -1;
+
+	param = offset & 0xff;
+
+	param = param | (value << 8);
+    
+	/* This function like the previous allow unlimited
+	   write access to ALL of the registers on the PCM-MIO
+   */
+
+	val = ioctl(handle,MIO_WRITE_REG,param);
+	
+	return 0;
+}
+
+
+///////////////////////////////////////////////////////////////////////////////
+//
+//		WRITE_DIO_BYTE
+//
+//////////////////////////////////////////////////////////////////////////////
+
+int write_dio_byte(int offset, unsigned char value)
+{
+unsigned short param;
+int val;
+
+	mio_error_code = MIO_SUCCESS;
+
+	if(check_handle())   /* Check for chip available */
+		return -1;
+
+	param = offset & 0xff;
+
+	param = param | (value << 8);
+    
+	/* All bit operations for the DIO are handled at this level
+	   and we need the driver to allow access to the actual
+	   DIO registers to update the value.
+    */
+
+	val = ioctl(handle,WRITE_DIO_BYTE,param);
+	
+	return 0;
+}
+
+
+///////////////////////////////////////////////////////////////////////////////
+//
+//		WRITE_DAC_COMMAND
+//
+//////////////////////////////////////////////////////////////////////////////
+
+int write_dac_command(int dac_num,unsigned char value)
+{
+unsigned short param;
+int val;
+
+	mio_error_code = MIO_SUCCESS;
+
+	if(check_handle())   /* Check for chip available */
+		return -1;
+
+	param = dac_num & 0xff;
+
+	param = param | (value << 8);
+
+	val = ioctl(handle,WRITE_DAC_COMMAND,param);
+
+	return 0;
+}
+
 
 ///////////////////////////////////////////////////////////////////////////////
@@ -943,4 +1124,29 @@
 ///////////////////////////////////////////////////////////////////////////////
 //
+//		WRITE_ADC_COMMAND
+//
+//////////////////////////////////////////////////////////////////////////////
+
+int write_adc_command(int adc_num,unsigned char value)
+{
+unsigned short param;
+int ret_val;
+
+	mio_error_code = MIO_SUCCESS;
+
+	if(check_handle())   /* Check for chip available */
+		return -1;
+
+	param = adc_num & 0xff;
+
+	param = param | (value << 8);
+
+    ret_val = ioctl(handle,WRITE_ADC_COMMAND,param);
+
+	return 0;
+}
+
+///////////////////////////////////////////////////////////////////////////////
+//
 //		BUFFERED_DAC_OUTPUT
 //
@@ -966,4 +1172,69 @@
 		x++;
 	}
+}
+
+///////////////////////////////////////////////////////////////////////////////
+//
+//		WRITE_DAC_DATA
+//
+//////////////////////////////////////////////////////////////////////////////
+
+int write_dac_data(int dac_num, unsigned short value)
+{
+int ret_val;
+unsigned char buffer[3];
+
+	mio_error_code = MIO_SUCCESS;
+
+	if(check_handle())   /* Check for chip available */
+		return -1;
+
+	buffer[0] = dac_num;
+	buffer[1] = value & 0xff;
+	buffer[2] = value >> 8;
+
+    ret_val = ioctl(handle,WRITE_DAC_DATA,buffer);
+	
+	return 0;
+}
+
+///////////////////////////////////////////////////////////////////////////////
+//
+//		DAC_READ_STATUS
+//
+//////////////////////////////////////////////////////////////////////////////
+
+unsigned char dac_read_status(int dac_num)
+{
+int ret_val;
+
+	mio_error_code = MIO_SUCCESS;
+
+	if(check_handle())   /* Check for chip available */
+		return -1;
+
+    ret_val = ioctl(handle,READ_DAC_STATUS,dac_num);
+
+	return ret_val & 0xff;
+}
+
+///////////////////////////////////////////////////////////////////////////////
+//
+//		ADC_READ_STATUS
+//
+//////////////////////////////////////////////////////////////////////////////
+
+unsigned char adc_read_status(int adc_num)
+{
+int ret_val;
+
+	mio_error_code = MIO_SUCCESS;
+
+	if(check_handle())   /* Check for chip available */
+		return -1;
+
+    ret_val = ioctl(handle,READ_ADC_STATUS,adc_num);
+
+	return (ret_val & 0xff);
 }
 
@@ -1058,4 +1329,31 @@
 }
 
+///////////////////////////////////////////////////////////////////////////////
+//
+//		ADC_READ_CONVERSION_DATA
+//
+//////////////////////////////////////////////////////////////////////////////
+
+unsigned short adc_read_conversion_data(int channel)
+{
+int ret_val;
+int adc_num;
+
+	mio_error_code = MIO_SUCCESS;
+
+	if(check_handle())   /* Check for chip available */
+		return -1;
+
+	if(channel > 7)
+		adc_num = 1;
+	else
+		adc_num = 0;
+
+    ret_val = ioctl(handle,READ_ADC_DATA,adc_num);
+	
+	return (ret_val & 0xffff);
+}
+
+
 ////////////////////////////////////////////////////////////////////////////////
 //
@@ -1496,2 +1794,96 @@
 }
 
+
+int dio_get_int(void)
+{
+int c;
+
+    c=ioctl(handle,DIO_GET_INT,NULL);
+
+    return (c & 0xff);
+
+}
+
+
+int wait_adc_int(int adc_num)
+{
+int c;
+
+
+    if(check_handle())   /* Check for chip available */
+		return -1;
+
+	if(adc_num)
+	    c=ioctl(handle,WAIT_A2D_INT_1,NULL);
+	else
+	    c=ioctl(handle,WAIT_A2D_INT_2,NULL);
+
+
+    return (c & 0xff);
+
+}
+
+
+int wait_dac_int(int dac_num)
+{
+int c;
+
+    if(check_handle())   /* Check for chip available */
+		return -1;
+
+	if(dac_num)
+	    c=ioctl(handle,WAIT_DAC_INT_1,NULL);
+	else
+	    c=ioctl(handle,WAIT_DAC_INT_2,NULL);
+
+    return (c & 0xff);
+
+}
+
+
+int wait_dio_int(void)
+{
+int c;
+
+
+    if(check_handle())   /* Check for chip available */
+		return -1;
+
+    c=ioctl(handle,WAIT_DIO_INT,NULL);
+
+    return (c & 0xff);
+
+}
+
+
+
+int check_handle(void)
+{
+    if(handle > 0)	/* If it's already a valid handle */
+		return 0;
+
+    if(handle == -1)	/* If it's already been tried */
+	{
+		mio_error_code = MIO_OPEN_ERROR;
+		sprintf(mio_error_string,"MIO - Unable to open device PCMMIO");
+		return -1;
+	}
+
+    /* Try opening the device file, in case it hasn't been opened yet */
+
+    handle = open(device_id,0);
+
+	/* Try an alternate open at /dev */
+
+	if(handle < 0)
+		handle = open(dev_id,0);
+
+    if(handle > 0)	/* If it's now a valid handle */
+		return 0;
+
+	mio_error_code = MIO_OPEN_ERROR;
+	sprintf(mio_error_string,"MIO - Unable to open device PCMMIO");
+    handle = -1;
+	return -1;
+}
+
Index: pcmmio/original/mio_io.h
===================================================================
--- pcmmio/original/mio_io.h	(revision dc256a455be7910f1b9e84fd51f47ae623a42509)
+++ pcmmio/original/mio_io.h	(revision 2bae2aa487be5c21a8eac5de5ba3c19d73b1651c)
@@ -7,10 +7,11 @@
  */
 
-/* $Id$ */
+/* $Log$
+*
+*/
 
 #ifndef CHARDEV_H
 #define CHARDEV_H
 
-#if defined(__linux__)
 #include <linux/ioctl.h> 
 
@@ -57,9 +58,8 @@
 #define DEVICE_FILE_NAME "pcmmio"
 
+
 #endif
 
-#endif
-
-/* These are the error codes for mio_error_code */
+/* These are the error codes doe mio_error_code */
 
 #define MIO_SUCCESS 0
@@ -118,10 +118,10 @@
 char mio_error_string[128];
 float adc_bitval[16] = {.00, .00, .00, .00, .00, .00, 00, .00,
-		        .00, .00, .00, .00, .00, .00, .00, .00 };
+							   .00, .00, .00, .00, .00, .00, .00, .00 };
 
 unsigned short adc_adjust[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };
 
 float adc_offset[16] = { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
-			 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 };
+						 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 };
 
 #else
@@ -143,7 +143,4 @@
 #endif
 
-/* part of the porting layer */
-int check_handle(void);
-int mio_read_irq_assigned(void);
 
 int disable_dio_interrupt(void);
@@ -156,4 +153,5 @@
 int wait_dac_ready(int channel);
 int set_dac_output(int channel, unsigned short dac_value);
+int set_dac_voltage(int channel, float voltage);
 int set_dac_voltage(int channel, float voltage);
 unsigned char read_dio_byte(int offset);
@@ -185,26 +183,47 @@
 int dio_clr_int(int bit_number);
 int dio_get_int(void);
-int dio_get_int_with_timestamp(
-  unsigned long long *timestamp
-);
 int wait_adc_int(int adc_num);
 int wait_dac_int(int dac_num);
 int wait_dio_int(void);
 
-#if defined(__rtems__)
-  void pcmmio_initialize(
-    unsigned short _base_port,
-    unsigned short _irq
-  );
-
-  void flush_buffered_ints(void);
-  int wait_adc_int_with_timeout(int adc_num, int milliseconds);
-  int wait_dac_int_with_timeout(int dac_num, int milliseconds);
-  int wait_dio_int_with_timeout(int milliseconds);
-  int wait_dio_int_with_timestamp(
-    int                 milliseconds,
-    unsigned long long *timestamp
-  );
-  int dio_get_missed_interrupts(void);
-#endif
-
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
Index: pcmmio/original/pcmmio.c
===================================================================
--- pcmmio/original/pcmmio.c	(revision dc256a455be7910f1b9e84fd51f47ae623a42509)
+++ pcmmio/original/pcmmio.c	(revision 2bae2aa487be5c21a8eac5de5ba3c19d73b1651c)
@@ -1,6 +1,14 @@
-/*
+/* PCMMIO.C    WinSystems PCM-MIO Linux Driver */
+
+/* 
+ * $Header$
+ * $Id$
+ *
+ * Filename : $RCSfile$
+ * 
+ * $Log$
+ *
+ *
  * WinSystems PCM-MIO Linux Device Driver
- * 
- * $Id$
  */
 
@@ -1017,2 +1025,3 @@
 }
 
+	
Index: pcmmio/original/poll.c
===================================================================
--- pcmmio/original/poll.c	(revision dc256a455be7910f1b9e84fd51f47ae623a42509)
+++ pcmmio/original/poll.c	(revision 2bae2aa487be5c21a8eac5de5ba3c19d73b1651c)
@@ -1,12 +1,19 @@
-/* poll.c
- * Demonstration program for WinSystems PCM-MIO Driver
- *
- * $Id$
- */
-
-/* This program demonstrates one manner in which an unprivileged 
- * application running in user space can synchronize to hardware events 
- * handled by a device driver running in Kernel space.
- */
+/* Poll.c Demonstration program for WinSystems PCM-MIO Driver */
+
+/*
+*
+* $Header$
+*
+* $Id$
+*
+* $Log$
+*
+*/
+
+/* This program demonstrates one manner in which an unprivledged 
+   application running in user space can sychronize to hardware events 
+   handled by a device driver running in Kernel space.
+*/
+
 
 #include "mio_io.h"    
@@ -20,5 +27,5 @@
 
 
-/* This function will be a sub-processes using the Posix threads 
+/* This function will be a sub-processe using the Posix threads 
    capability of Linux. This thread will simulate a type of 
    Interrupt service routine in that it will start up and then suspend 
Index: pcmmio/original/repeat.c
===================================================================
--- pcmmio/original/repeat.c	(revision dc256a455be7910f1b9e84fd51f47ae623a42509)
+++ pcmmio/original/repeat.c	(revision 2bae2aa487be5c21a8eac5de5ba3c19d73b1651c)
@@ -1,15 +1,22 @@
-/* repeat.c
- * Demonstration program for WinSystems PCM-MIO Driver
- *
- * $Id$
- *
- * Compile for GNU/Linux with:
- *
- *    gcc repeat.c kbhit.c mio_io.o -o repeat
- *
- * This program demonstrates the adc_convert_single_repeated function
- * which allows for a sequence of conversions to be accomplished
- * with a single call on the same channel.
- */
+/* repeat.c Demonstration program for WinSystems PCM-MIO Driver */
+
+/*
+*
+* $Header$
+*
+* $Id$
+*
+* $Log$
+*
+*	Compile with :
+*
+*		gcc repeat.c kbhit.c mio_io.o -o repeat
+*
+*
+*	This program demonstrates the adc_convert_single_repeated function
+*	which allows for a sequence of conversions to be accomplished
+*	with a single call on the same channel.
+*
+*/
 
 #include "mio_io.h"    
